# Solved

Collection of programming problems solutions, writing in c++ from different online judges (LeetCode, MOI Arena, Codeforces, HackerRank, ...)

|                                                                    | Type                         | Source                                                                      |
| :----------------------------------------------------------------- | :--------------------------- | :-------------------------------------------------------------------------- |
| [Wood factory](arena/Wood-factory.cpp) (\*Can be better)           | Two pointers                 | [MOI Arena ➚](https://arena.moi/problem/round9carpentry)                    |
| [Snake](arena/Snake.cpp)                                           | Math                         | [MOI Arena ➚](https://arena.moi/problem/round5snake)                        |
| [Welcome MOI 2022](arena/MOI22-Qualification/Welcome-MOI-2022.cpp) | MOI22 Qualification          | [MOI Arena ➚](https://arena.moi/problems)                                   |
| [File-system](arena/MOI22-Qualification/File-system.cpp)           | MOI22 Qualification          | [MOI Arena ➚](https://arena.moi/problems)                                   |
| [Repeated digits](arena/Repeated-Digits.cpp)                       | Ad-Hoc                       | [MOI Arena ➚](https://arena.moi/problem/interviewrepeateddig)               |
| [Reverse a linked list](hackerrank/Reverse-linked-list.cpp)        | Linked Lists                 | [HackerRank ➚](https://www.hackerrank.com/challenges/reverse-a-linked-list) |
| [Loading ships](arena/Loading-ships.cpp)                           | Binary search                | [MOI Arena ➚](https://arena.moi/problem/seed2)                              |
| [Arena servers](arena/MOI21-Practice/Arena-servers.cpp)            | Ad-Hoc                       | [MOI Arena ➚](https://arena.moi/problem/mdc1arenaservers)                   |
| [Last digit!](arena/MOI21-Practice/Last-digite.cpp)                | Sorting / Math               | [MOI Arena ➚](https://arena.moi/problem/gc4lastdigit)                       |
| [Acrobats](arena/MOI21-Practice/Acrobats.cpp)                      | Ad-Hoc                       | [MOI Arena ➚](https://arena.moi/problem/moij2020acrobat)                    |
| [Azuz's anagram](arena/MOI21-Practice/Azuz-anagram.cpp)            | Simple Math / Sorting        | [MOI Arena ➚](https://arena.moi/problem/gc4azuzanagram)                     |
| [Wrong Subtraction](codeforces/Wrong-Subtraction.cpp)              | Ad-Hoc                       | [Codeforces ➚](https://codeforces.com/contest/977/problem/A)                |
| [Another string](arena/Another-string.cpp)                         | Strings                      | [MOI Arena ➚](https://arena.moi/problem/mcpc18acestring)                    |
| [Longest increasing subsequence](arena/Dplessonlis.cpp)            | Dynamic programming          | [MOI Arena ➚](https://arena.moi/problem/dplessonlis)                        |
| [Arrays](arena/Arrays.cpp)                                         | Ad-Hoc / Sorting             | [MOI Arena ➚](https://arena.moi/problem/ncc20array)                         |
| [Merge them up](arena/Merge-them-up.cpp)                           | Two pointers                 | [MOI Arena ➚](https://arena.moi/problem/divmergethemup)                     |
| [Count paths](arena/Count-paths.cpp)                               | Dynamic programming          | [MOI Arena ➚](https://arena.moi/problem/dplessoncountpaths)                 |
| [Diaa Was Live!](arena/Diaa-was-live.cpp)                          | Math                         | [MOI Arena ➚](https://arena.moi/problem/gc5countdigits)                     |
| [Fibonacci queries](arena/Fibonacci-queries.cpp)                   | Dynamic programming          | [MOI Arena ➚](https://arena.moi/problem/dplessonfibo)                       |
| [Binary string](arena/Binary-string.cpp)                           | Strings                      | [MOI Arena ➚](https://arena.moi/problem/round6binary)                       |
| [Corona Virus Alert](arena/Corona-virus-alert.cpp)                 | Simple Math                  | [MOI Arena ➚](https://arena.moi/problem/gc5covidalert)                      |
| [Corona Virus Spread](arena/Corona-virus-spread.cpp)               | Ad-Hoc                       | [MOI Arena ➚](https://arena.moi/problem/gc5covidspread)                     |
| [Eliot Andersol](arena/Eliot-andersol.cpp)                         | Geometry                     | [MOI Arena ➚](https://arena.moi/problem/mdc1eliotandersol)                  |
| [Help parent](arena/Help-parent.cpp)                               | Ad-Hoc                       | [MOI Arena ➚](https://arena.moi/problem/ncc20help)                          |
| [Houda Playing Pocker](arena/Houda-playing-pocker.cpp)             | Simple Math                  | [MOI Arena ➚](https://arena.moi/problem/gc4houdaplayingpock)                |
| [Maximum subarray](arena/Maximum-subarray.cpp)                     | Dynamic programming          | [MOI Arena ➚](https://arena.moi/problem/dplessonkadane)                     |
| [Play with Hicham](arena/Play-with-Hicham.cpp)                     | Ad-Hoc                       | [MOI Arena ➚](https://arena.moi/problem/ncc20hicham)                        |
| [Stable Zeroing](arena/Stable-zeroing.cpp)                         | Simple Math                  | [MOI Arena ➚](https://arena.moi/problem/gc4stablezeroing)                   |
| [String operations](arena/String-operations.cpp)                   | Ad-Hoc                       | [MOI Arena ➚](https://arena.moi/problem/round7operations)                   |
| [High school mathematics](arena/HSchool-maths.cpp)                 | Math                         | [MOI Arena ➚](https://arena.moi/problem/gc4highschoolmat)                   |
| <img width="440" height="0">                                       | <img width="178" height="0"> | <img width="124" height="0">                                                |

<!-- Last empty row is to ensure each column take the appropriate space --->

# Running the code

VsCode is the recommended IDE to run the code with. It's also configured to run the code in a DevContainer and has all the required tools and dependencies installed.

Some useful commands:

```bash
# Compile and run the code
g++ -g <file-name> -o <output-name> && ./<output-name>

# Format the code
clang-format -i -style="{BasedOnStyle: WebKit, BreakBeforeBraces: Attach}" <file-path>
```

---

<p align="center">Made with ❤️ by <a href="https://www.rabraghib.me">Rabyâ Raghib</a></p>
